' FFSubmenu=Tools
' FFName=Datenblitz-Tool
' FFScriptFiles=datenblitztool.vbs
' FFScriptDirectory=datenblitztool
' FFScriptProfile=DatenblitzTool
' Einstellung der Datenanzeige in der Ganzbildschirmansicht
' Verwaltung verschiedener Datenblitz-Settings
' KGsoft (praetor), 
' Version 4.4 vom 24.09.2011
' Version 4.5 vom 20.03.2012	nur nderung in datenblitz.vbs
' Version 4.6 vom 27.03.2012	nur nderung in datenblitz.vbs
' Version 4.7 vom 08.04.2012	nur nderung in datenblitz.vbs
' Version 4.8 vom 13.07.2012	nur nderung in datenblitz.vbs
' Version 4.9 vom 20.09.2012	Maskierung im Hilfeaufruf
' Version 5.0 vom 25.11.2013	nur nderung in datenblitz.vbs
' Version 5.1 vom 26.11.2013	nur nderung in datenblitz.vbs

Option Explicit

Const Version = "V 5.1"
const RegSchluessel = "DatenblitzTool"						'Registryschlssel
const on_picture = "an3.png"
const off_picture = "aus3.png"
const del_picture = "kreuz4.png"
Const ForReading = 1
Const ForWriting = 2
Dim Taste, aktini, aktinialt
Dim Editor
Dim WshShell, Aufruf
Set WSHShell = CreateObject("WScript.Shell")
Dim fso, objFile
Set fso = CreateObject("Scripting.FileSystemObject")

' fr Hilfe
Dim Taste2
Dim objFs, Kurzbeschreibung, KBvorhanden, LaengeMax
'Dim WshShell
const SkriptName = "datenblitztool.vbs"			' Skriptname

' Startbedingung
Call RegLesen
if aktini = "" Then
	aktini = 1			' 1. Setting ist aktiv
End If

Call Dialogaufbau
Call Buttonicons
If Version_equal_or_better("3.30.06") Then Call Tooltipps	' Tooltips erst ab 3.30 beta 6
Call Main

Sub Main
Do							' erneute Anzeige des Dialogs, solange Tastenbilder gendert
	Do						' Dialoganzeige und Tastenabfrageregedit
		Taste = FF_ShowDialog("Datenblitz-Tool")
		Select Case Taste
			Case "1_button"
				aktinialt = aktini
				aktini = 1
				Call Umkopieren
				FF_CloseDialog "Datenblitz-Tool"
				Exit Do	
			Case "2_button"
				aktinialt = aktini
				aktini = 2
				Call Umkopieren
				FF_CloseDialog "Datenblitz-Tool"
				Exit Do	
			Case "3_button"
				aktinialt = aktini
				aktini = 3
				Call Umkopieren
				FF_CloseDialog "Datenblitz-Tool"
				Exit Do	
			Case "4_button"
				aktinialt = aktini
				aktini = 4
				Call Umkopieren
				FF_CloseDialog "Datenblitz-Tool"
				Exit Do	
			case "5_button"
				aktinialt = aktini
				aktini = 5
				Call Umkopieren
				FF_CloseDialog "Datenblitz-Tool"
				Exit Do	
			Case "Edit"
				if Editor <> "" Then
					Aufruf = Editor & " " & FF_GetFFPathEx(2) & "\datenblitz.ini"
				Else	
					Aufruf = Chr(34) & FF_GetFFPathEx(2) & "\datenblitz.ini" & Chr(34)
				End If
				WSHShell.Run Aufruf
				If Version_equal_or_better("3.30.06") Then Call Tooltipps	' Tooltips erst ab 3.30 beta 6
			Case "Editor auswhlen"
				Editor = FF_EnterFileName(True, "*.exe")
				If Editor <> "" Then				' Programm wurde gewhlt
					if len (Editor) < 32 Then
						FF_SetControl "Datenblitz-Tool","editor_edit", Editor
					Else
						FF_SetControl "Datenblitz-Tool","editor_edit", Left(Editor, 5) & " ... " & Right (Editor, 25)	' Anzeige verkrzen
					End If
				End If
			Case "x"		' Editor-Einstellung lschen
				FF_SetControl "Datenblitz-Tool","editor_edit", ""
			Case "OK"
				Call RegSchreiben
				Exit Sub
			Case "CANCEL"
				Call RegSchreiben
				Exit Sub
			Case "?"
				REM WshShell.Run """C:\Program Files\Notepad++\notepad++.exe""" & " " & """D:\Eigene Dateien\Eigene Dokumente\history.log""",3,false
				REM MsgBox Chr(34) & FF_GetFFPathEx(2) & "\datenblitztool\dblitzhelp.pdf" & Chr(34)
				WSHShell.Run Chr(34) & FF_GetFFPathEx(2) & "\datenblitztool\dblitzhelp.pdf" & Chr(34)
				REM Call Help
		End Select
	loop
		Call Dialogaufbau
		Call Buttonicons
		If Version_equal_or_better("3.30.06") Then Call Tooltipps	' Tooltips erst ab 3.30 beta 6
Loop
End Sub

Sub Umkopieren
	Dim ifile
	' datenblitz.ini in Toolordner sichern
	If Not fso.FileExists(FF_GetFFPathEx(2) & "\datenblitz.ini") Then		' wenn es datenblitz.ini nicht gibt ...
		fso.CopyFile FF_GetFFPathEx(2) & "\datenblitztool\vorlage\0datenblitz.ini", FF_GetFFPathEx(2) & "\"		' ... aus 0datenblitz.ini restaurieren
		set ifile = fso.GetFile(FF_GetFFPathEx(2) & "\0datenblitz.ini")		' umbenennen
		ifile.name = "datenblitz.ini"
	End If
	' Prfe, ob es (als Fehler) die Zieldatei in Tool-Order gib, wenn ja: lschen
	If fso.FileExists(FF_GetFFPathEx(2) & "\datenblitztool\" & aktinialt & "datenblitz.ini") Then
		fso.DeleteFile FF_GetFFPathEx(2) & "\datenblitztool\" & aktinialt & "datenblitz.ini"
	End If
	fso.MoveFile FF_GetFFPathEx(2) & "\datenblitz.ini", FF_GetFFPathEx(2) & "\datenblitztool\" & aktinialt & "datenblitz.ini"
	
	' neue Ziffern-Ini zur datenblitz.ini verschieben
	If Not fso.FileExists(FF_GetFFPathEx(2) & "\datenblitztool\" & aktini & "datenblitz.ini") Then	' wenn es Ziffern-Ini im Toolordner nicht gibt
		fso.CopyFile FF_GetFFPathEx(2) & "\datenblitztool\vorlage\0datenblitz.ini", FF_GetFFPathEx(2) & "\datenblitztool\"		' ... aus 0datenblitz.ini restaurieren
		set ifile = fso.GetFile(FF_GetFFPathEx(2) & "\datenblitztool\0datenblitz.ini")		' umbenennen
		ifile.name = aktini & "datenblitz.ini"
	End If
	' Prfe, ob es (als Fehler) die datenblitz.ini im Skript-Ordner gib, wenn ja: lschen
	If fso.FileExists(FF_GetFFPathEx(2) & "\datenblitz.ini") Then
		fso.DeleteFile FF_GetFFPathEx(2) & "\datenblitz.ini"
	End If
	fso.MoveFile FF_GetFFPathEx(2) & "\datenblitztool\" & aktini & "datenblitz.ini", FF_GetFFPathEx(2) & "\datenblitz.ini"	
	
End Sub

Sub RegLesen
	aktini = FF_GetProfile(RegSchluessel, "aktini")
	Editor = FF_GetProfile(RegSchluessel, "editor")
End Sub

Sub RegSchreiben
	FF_WriteProfile RegSchluessel,"aktini", aktini
	FF_WriteProfile RegSchluessel,"editor", Editor
End Sub

Sub Dialogaufbau
	'** Start Dialog Datenblitz-Tool **
	FF_AddDialog "Datenblitz-Tool",114,117
	FF_AddControl "Datenblitz-Tool","Optionen","GROUP",2,63,109,35
	FF_AddControl "Datenblitz-Tool","Datenblitz-Settings","GROUP",2,3,109,56
	FF_AddControl "Datenblitz-Tool","1_button","BUTTON",5,21,17,17
	FF_AddControl "Datenblitz-Tool","2_button","BUTTON",26,21,18,18
	FF_AddControl "Datenblitz-Tool","3_button","BUTTON",47,21,18,18
	FF_AddControl "Datenblitz-Tool","4_button","BUTTON",68,21,18,18
	FF_AddControl "Datenblitz-Tool","5_button","BUTTON",89,21,18,18
	FF_AddControl "Datenblitz-Tool","OK","BUTTON",74,102,33,11
	FF_AddControl "Datenblitz-Tool","?","BUTTON",38,102,11,11
	FF_AddControl "Datenblitz-Tool","Edit","BUTTON",74,43,33,11
	FF_AddControl "Datenblitz-Tool","I","STATIC",14,10,7,11
	FF_AddControl "Datenblitz-Tool","II","STATIC",34,10,7,11
	FF_AddControl "Datenblitz-Tool","III","STATIC",53,10,9,11
	FF_AddControl "Datenblitz-Tool","IV","STATIC",74,10,9,11
	FF_AddControl "Datenblitz-Tool","V","STATIC",97,10,9,11
	FF_AddControl "Datenblitz-Tool","editor_edit","EDIT",5,85,102,10
	FF_AddControl "Datenblitz-Tool","Editor auswhlen","BUTTON",5,72,47,11
	FF_AddControl "Datenblitz-Tool","x","BUTTON",56,73,9,9
	FF_SetControlStyle "Datenblitz-Tool","x",768
	FF_SetControlImage "Datenblitz-Tool", "x", FF_GetFFPathEx(2) & "\datenblitztool\" & del_picture
	'** End Dialog Datenblitz-Tool **

	FF_AddControl "Datenblitz-Tool",Version,"STATIC",53,102,18,11
	FF_SetControlStyle "Datenblitz-Tool",Version,1
	
	If Editor <> "" Then				' Editor ist definiert
		if len (Editor) < 32 Then
			FF_SetControl "Datenblitz-Tool","editor_edit", Editor
		Else
			FF_SetControl "Datenblitz-Tool","editor_edit", Left(Editor, 5) & " ... " & Right (Editor, 25)	' Anzeige verkrzen
		End If
	End If
End Sub

Sub Buttonicons
	Select Case aktini
		Case 1
			FF_SetControlImage "Datenblitz-Tool", "1_button", FF_GetFFPathEx(2) & "\datenblitztool\" & on_picture
			FF_SetControlImage "Datenblitz-Tool", "2_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
			FF_SetControlImage "Datenblitz-Tool", "3_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
			FF_SetControlImage "Datenblitz-Tool", "4_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
			FF_SetControlImage "Datenblitz-Tool", "5_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
		Case 2
			FF_SetControlImage "Datenblitz-Tool", "2_button", FF_GetFFPathEx(2) & "\datenblitztool\" & on_picture
			FF_SetControlImage "Datenblitz-Tool", "1_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
			FF_SetControlImage "Datenblitz-Tool", "3_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
			FF_SetControlImage "Datenblitz-Tool", "4_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
			FF_SetControlImage "Datenblitz-Tool", "5_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
		Case 3
			FF_SetControlImage "Datenblitz-Tool", "3_button", FF_GetFFPathEx(2) & "\datenblitztool\" & on_picture
			FF_SetControlImage "Datenblitz-Tool", "2_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
			FF_SetControlImage "Datenblitz-Tool", "1_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
			FF_SetControlImage "Datenblitz-Tool", "4_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
			FF_SetControlImage "Datenblitz-Tool", "5_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
		Case 4
			FF_SetControlImage "Datenblitz-Tool", "4_button", FF_GetFFPathEx(2) & "\datenblitztool\" & on_picture
			FF_SetControlImage "Datenblitz-Tool", "2_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
			FF_SetControlImage "Datenblitz-Tool", "3_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
			FF_SetControlImage "Datenblitz-Tool", "1_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
			FF_SetControlImage "Datenblitz-Tool", "5_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
		Case 5
			FF_SetControlImage "Datenblitz-Tool", "5_button", FF_GetFFPathEx(2) & "\datenblitztool\" & on_picture
			FF_SetControlImage "Datenblitz-Tool", "2_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
			FF_SetControlImage "Datenblitz-Tool", "3_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
			FF_SetControlImage "Datenblitz-Tool", "4_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
			FF_SetControlImage "Datenblitz-Tool", "1_button", FF_GetFFPathEx(2) & "\datenblitztool\" & off_picture
	End Select
End Sub

Sub Tooltipps
	on error resume next
	
	Const ForReading = 1
	Dim Skript, Zeile, TTT_ini, TTT_1, TTT_2, TTT_3, TTT_4, TTT_5 
	Set objFS = CreateObject("Scripting.FileSystemObject")	 ' FileSystemObject
	
	Set Skript = objFS.OpenTextFile(FF_GetFFPathEx(2) & "\" & "datenblitz.ini", ForReading, False)
	Zeile = Skript.ReadLine
	if instr(Zeile,"IniBeschreibung") > 0 then TTT_ini = Trim(Right(Zeile, Len (Zeile) - InStrRev(Zeile, "=",-1, 1)))
	
	Set Skript = objFS.OpenTextFile(FF_GetFFPathEx(2) & "\datenblitztool\" & "1datenblitz.ini", ForReading, False)
	Zeile = Skript.ReadLine
	if instr(Zeile,"IniBeschreibung") > 0 then TTT_1 = Trim(Right(Zeile, Len (Zeile) - InStrRev(Zeile, "=",-1, 1)))
	
	Set Skript = objFS.OpenTextFile(FF_GetFFPathEx(2) & "\datenblitztool\" & "2datenblitz.ini", ForReading, False)
	Zeile = Skript.ReadLine
	if instr(Zeile,"IniBeschreibung") > 0 then TTT_2 = Trim(Right(Zeile, Len (Zeile) - InStrRev(Zeile, "=",-1, 1)))

	Set Skript = objFS.OpenTextFile(FF_GetFFPathEx(2) & "\datenblitztool\" & "3datenblitz.ini", ForReading, False)
	Zeile = Skript.ReadLine
	if instr(Zeile,"IniBeschreibung") > 0 then TTT_3 = Trim(Right(Zeile, Len (Zeile) - InStrRev(Zeile, "=",-1, 1)))

	Set Skript = objFS.OpenTextFile(FF_GetFFPathEx(2) & "\datenblitztool\" & "4datenblitz.ini", ForReading, False)
	Zeile = Skript.ReadLine
	if instr(Zeile,"IniBeschreibung") > 0 then TTT_4 = Trim(Right(Zeile, Len (Zeile) - InStrRev(Zeile, "=",-1, 1)))

	Set Skript = objFS.OpenTextFile(FF_GetFFPathEx(2) & "\datenblitztool\" & "5datenblitz.ini", ForReading, False)
	Zeile = Skript.ReadLine
	if instr(Zeile,"IniBeschreibung") > 0 then TTT_5 = Trim(Right(Zeile, Len (Zeile) - InStrRev(Zeile, "=",-1, 1)))	
	
	FF_SetControlTooltip "Datenblitz-Tool","1_button", TTT_1
	FF_SetControlTooltip "Datenblitz-Tool","2_button", TTT_2
	FF_SetControlTooltip "Datenblitz-Tool","3_button", TTT_3
	FF_SetControlTooltip "Datenblitz-Tool","4_button", TTT_4
	FF_SetControlTooltip "Datenblitz-Tool","5_button", TTT_5
		
	Select Case aktini
		Case 1
			FF_SetControlTooltip "Datenblitz-Tool","1_button", TTT_ini
		Case 2
			FF_SetControlTooltip "Datenblitz-Tool","2_button", TTT_ini
		Case 3
			FF_SetControlTooltip "Datenblitz-Tool","3_button", TTT_ini
		Case 4
			FF_SetControlTooltip "Datenblitz-Tool","4_button", TTT_ini
		Case 5
			FF_SetControlTooltip "Datenblitz-Tool","5_button", TTT_ini
	End Select
	
	On Error Goto 0
End Sub

Function Version_equal_or_better(p_Vers)
	Dim l_VersNr
	l_VersNr=split(p_Vers,".")
	version_equal_or_better=(FF_GetMajor*1000+FF_GetMinor+FF_GetBuild/1000 >= l_VersNr(0)*1000+l_VersNr(1)+l_VersNr(2)/1000)
End Function

Sub Help
	if not KBvorhanden then	call KurzbeschreibungLesen
	if KBvorhanden then
		set WshShell =  CreateObject("WScript.Shell")
		WshShell.Popup Kurzbeschreibung,,"Info"
	else
		msgbox "Keine Kurzbeschreibung gefunden!",,"Meldung"
	end if
End Sub

'** Start Kurzbeschreibung *********************************
'Datenblitz & Datenblitz-Tool
'====================================================
'
'Mit Datenblitz ist in der Ganzbildschirmansicht die strukturierte Anzeige aller Exif- und IPTC-Daten, die FF ermitteln kann, mglich.
'Welche Meta-Daten dabei im Einzelnen dargestellt werden, wird in der Datei datenblitz.ini definiert, die im Scriptverzeichnis abgelegt ist.
'
'Damit der Datenblitz aktiv wird, muss das Script datenblitz.vbs in FixFoto unter Datei -> Einstellungen -> Diveres in der Rubrik "BildinfoSkript fr Ganzbildschirm Ansicht" eingetragen werden.
'
'Das Datenblitz-Tool ergnzt den Datenblitz. Mit dem Datenblitz-Tool knnen fnf verschiedene Settings fr die datenblitz.ini verwaltet und zwischen Ihnen kann rasch umgeschaltet werden. Damit ist es auf einfache Weise mglich, fr unterschiedliche Einsatzzwecke (z.B. schnelle Bilderdurchsicht / eingehende Analyse der Aufnahmeparameter) jeweils angepasste Einstellungen vorzuhalten.

'Die vier gerade nicht aktiven Settings sind im Script-Ordner im Unterordner /datenblitztool/ abgelegt.

'ber <Edit> wird das jeweils aktive Setting mit dem Standardeditor geffnet und kann bearbeitet werden. Speichern danach nicht vergessen! ber die Option <Editor auswhlen> ist es zudem mglich, einen speziellen Texteditor anzugeben.

'[Andreas Kleingnther  2011]
'** Ende Kurzbeschreibung **********************************

Sub KurzbeschreibungLesen
	on error resume next
	Const ForReading = 1
	Dim Skript, Anfang, Ende, Zeile
	
	Set objFS = CreateObject("Scripting.FileSystemObject")	 ' FileSystemObject
	Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)
	
	if err.number = 53 then
		msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   	"Die Kurzbeschreibung kann daher nicht angezeigt werden.",,"Meldung"
		exit sub
	end if
		
	Do While Skript.AtEndOfStream <> True
		Zeile = Skript.ReadLine
		
		if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
		if Ende then exit do
		
		if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
		if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
		
		if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	Loop
	if Anfang and Ende then KBvorhanden = true
	Skript.Close
	 On Error GoTo 0
End Sub
